﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Collections.Generic;

namespace LD31
{
    // I WANT POINTERS
    class Agent
    {
        bool processing = false;
        public bool ProcessingMoves { get { return processing; } }

        float walkTime = 0f;
        public float health;
        Rectangle rect; // not rekt
        Vector2 pos;
        Texture2D tex;

        Dimension2D dir = new Dimension2D();
        Dimension2D movingTo = new Dimension2D(-1, -1);

        SpriteEffects effect = SpriteEffects.None;

        public Dimension2D GetWorldPos()
        {
            return World.ConvertToWorld(pos);
        }
        public Vector2 GetPos() { return this.pos; }

        public Dimension2D Direction
        {
            get { return dir; }
            set
            {
                dir = value;

                IsWalking = dir.X == 0 && dir.Y == 0 ? false : true;

                if (IsWalking && dir.X != 0) effect = value.X < 0 ? SpriteEffects.FlipHorizontally : SpriteEffects.None;
            }
        }

        List<Dimension2D> moves = new List<Dimension2D>();

        public float speed = 200;
        float time = 0f;
        byte anim = 0;
        byte frames;

        public float addWalkTime = 0;
        public int bombsPlaced = 0;
        public int maxBombs = 1;

        bool hurt = false;
        private bool isWalking = false;
        public bool IsWalking
        {
            get { return isWalking; }
            set
            {
                if (value != isWalking)
                {
                    if (value)
                    {
                        anim = 1;
                        rect.X = rect.Width;
                    }
                    else
                    {
                        time = 0f;
                        anim = 0;
                        rect.X = 0;
                    }
                    isWalking = value;
                }
            }
        }

        public Agent(Texture2D texture, Vector2 position, byte frameCount = 3/*hahahah defaulht*/)
        {
            this.tex = texture;
            this.pos = position;
            this.frames = frameCount;

            rect.X = 0;
            rect.Y = 0;
            rect.Width = tex.Width / (frameCount + 1); // +1 for fire
            rect.Height = tex.Height;

            health = 100f;
        }

        public bool Hurt(float dmg)
        {
            time = 0f;
            rect.X = frames * rect.Width;
            health -= dmg;

            hurt = true;
            return health <= 0.0f;
        }

        public void Update(float delta, ref World world)
        {
            if (processing)
            {
                walkTime += delta;
                if (walkTime >= 700 + addWalkTime)
                {
                    Dimension2D current = GetWorldPos();
                    dir.X = moves[0].X - current.X;
                    dir.Y = moves[0].Y - current.Y;

                    current.X += dir.X;
                    current.Y += dir.Y;
                    pos = new Vector2(current.X, current.Y) * World.BLOCK_SIZE;
                    walkTime = 0f;
                    addWalkTime = 0f;
                    removeLastMove();
                }
            }

            if (hurt)
            {
                time += delta;
                if (time >= 221)
                {
                    hurt = false;
                    time = 0f;

                    if (isWalking)
                    {
                        if (anim < frames - 1)
                        {
                            anim++;
                        }
                        else
                        {
                            anim = 1;
                        }
                    }
                    else
                    {
                        anim = 0;
                    }

                    rect.X = anim * rect.Width;
                }
            }

            if (isWalking)
            {
                if (!hurt)
                {
                    time += delta;
                    if (time >= 311)
                    {
                        time = 0f;

                        if (anim < frames - 1)
                        {
                            anim++;
                        }
                        else
                        {
                            anim = 1;
                        }

                        rect.X = anim * rect.Width;
                    }
                }

                /*if (needsCheck && moves.Count > 0)
                {
                    

                    if (current.X + dir.X > World.SIZE || current.X + dir.X < 0 ||
                        current.Y + dir.Y > World.SIZE || current.Y + dir.Y < 0)
                    {
                        removeLastMove();
                    }
                    else needsCheck = false;
                }*/

                if (!processing)
                {
                    Vector2 vel = new Vector2(dir.X, dir.Y) * speed * delta / 1000;

                    if (dir.X != 0)
                    {
                        float x = pos.X + vel.X + (dir.X > 0 ? World.BLOCK_SIZE : 0);
                        Dimension2D target = World.ConvertToWorld(new Vector2(x, pos.Y));

                        if (world.CanWalkHere(target))
                        {
                            int rem = (int)pos.Y % World.BLOCK_SIZE;

                            if (rem != 0 && (rem <= 5/* || rem >= World.BLOCK_SIZE - 6*/))
                            {
                                rem = 0;
                                pos.Y = GetWorldPos().Y * World.BLOCK_SIZE;
                            }

                            if (rem == 0 ? true : world.CanWalkHere(World.ConvertToWorld(new Vector2(x, pos.Y + World.BLOCK_SIZE))))
                            {
                                pos.X += vel.X;
                            }
                        }
                        else
                        {
                            Dimension2D current = World.ConvertToWorld(pos);

                            pos.X = current.X == target.X ? current.X * World.BLOCK_SIZE : (target.X + (dir.X < 0 ? 1 : -1)) * World.BLOCK_SIZE;
                        }
                    }

                    if (dir.Y != 0)
                    {
                        float y = pos.Y + vel.Y + (dir.Y > 0 ? World.BLOCK_SIZE : 0);
                        Dimension2D target = World.ConvertToWorld(new Vector2(pos.X, y));

                        if (world.CanWalkHere(target))
                        {
                            int rem = (int)pos.X % World.BLOCK_SIZE;

                            if (rem != 0 && (rem <= 5/* || rem >= World.BLOCK_SIZE - 6*/))
                            {
                                rem = 0;
                                pos.X = GetWorldPos().X * World.BLOCK_SIZE;
                            }

                            if (rem == 0 ? true : world.CanWalkHere(World.ConvertToWorld(new Vector2(pos.X + World.BLOCK_SIZE, y))))
                            {
                                pos.Y += vel.Y;
                            }
                        }
                        else
                        {
                            Dimension2D current = World.ConvertToWorld(pos);

                            pos.Y = current.Y == target.Y ? current.Y * World.BLOCK_SIZE : (target.Y + (dir.Y < 0 ? 1 : -1)) * World.BLOCK_SIZE;
                        }
                    }
                }
            }
        }

        void removeLastMove()
        {
            moves.RemoveAt(0);
            if (moves.Count == 0)
            {
                processing = false;
                isWalking = false;
            }
        }

        public bool PlaceBomb(ref World world, byte index)
        {
            if (bombsPlaced < maxBombs)
            {
                Dimension2D p1 = World.ConvertToWorld(pos);
                Dimension2D p2 = new Dimension2D(p1.X + 1, p1.Y + 1);
                Dimension2D closest = new Dimension2D();

                if (difference(p1.X * World.BLOCK_SIZE, pos.X) < difference(p2.X * World.BLOCK_SIZE, pos.X))
                {
                    closest.X = p1.X;
                }
                else
                {
                    closest.X = p2.X;
                }

                if (difference(p1.Y * World.BLOCK_SIZE, pos.Y) < difference(p2.Y * World.BLOCK_SIZE, pos.Y))
                {
                    closest.Y = p1.Y;
                }
                else
                {
                    closest.Y = p2.Y;
                }

                world.Set(closest, new Bomb(new Vector2(closest.X * World.BLOCK_SIZE, closest.Y * World.BLOCK_SIZE), index));

                bombsPlaced++;
                return true;
            }
            return false;
        }

        public void Draw(SpriteBatch sb)
        {
            sb.Draw(tex, pos, rect, Color.White, 0, Vector2.Zero, 1, effect, 0);
        }


        public void MoveTo(Dimension2D pos)
        {
            moves.Add(pos);
            processing = true;
            isWalking = true;
        }

        static float difference(float a, float b)
        {
            float diff = b - a;
            if (diff < 0) diff *= -1;
            return diff;
        }
    }
}
