﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace LD31
{
    class TextManager
    {
        SpriteFont font;

        float time;
        float targetTime;

        string text;

        Vector2 pos;
        Color color;

        bool shouldDraw = false;

        public TextManager(SpriteFont f)
        {
            this.font = f;
            time = 0f;
        }

        public void Update(float delta)
        {
            time += delta;
            time += time / 600 * delta;
            if (time < targetTime)
            {
                color.A = (byte)((targetTime - time) * 255 / targetTime);
            }
            else
            {
                shouldDraw = false;
                color = new Color(0, 0, 0, 0);
            }
        }

        public void Set(string txt, float tim = 3100, byte textWidth = 21)
        {
            this.text = txt;
            this.targetTime = tim;
            this.time = 0f;

            pos = new Vector2(Main.ScreenWidth / 2 - (text.Length * textWidth) / 2, Main.ScreenHeight / 2 - 100);
            color = Color.White;

            shouldDraw = true;
        }

        public void Draw(SpriteBatch sb)
        {
            if (shouldDraw)
            {
                sb.DrawString(font, text, pos, color);
            }
        }
    }
}
